diff -urN ../sys/net/bridge.c ./net/bridge.c
--- ../sys/net/bridge.c	Sat Feb 10 08:13:41 2001
+++ ./net/bridge.c	Tue Oct  2 22:06:21 2001
@@ -79,6 +79,9 @@
 
 #include <net/if.h>
 #include <net/if_types.h>
+#ifdef ALTQ
+#include <net/if_llc.h>
+#endif
 
 #include <netinet/in.h> /* for struct arpcom */
 #include <netinet/in_systm.h>
@@ -607,7 +610,7 @@
 {
     struct ifnet *src = m0->m_pkthdr.rcvif; /* could be NULL in output */
     struct ifnet *ifp, *last = NULL ;
-    int s ;
+    int error = 0, s ;
     int shared = bdg_copy ; /* someone else is using the mbuf */
     int once = 0;      /* loop only once */
     struct ifnet *real_dst = dst ; /* real dst from ether_output */
@@ -780,6 +783,13 @@
     for (;;) {
 	if (last) { /* need to forward packet leftover from previous loop */
 	    struct mbuf *m ;
+	    short mflags;
+	    int len;
+#ifdef ALTQ
+	    struct altq_pktattr pktattr;
+	    int af;
+#endif
+
 	    if (shared == 0 && once ) { /* no need to copy */
 		m = m0 ;
 		m0 = NULL ; /* original is gone */
@@ -790,6 +800,26 @@
 		    return m0 ; /* the original is still there... */
 		}
 	    }
+#ifdef ALTQ
+	    if (ALTQ_IS_ENABLED(&last->if_snd)) {
+		    u_short	ether_type;
+
+		    /*
+		     * if the queueing discipline needs packet classification,
+		     * do it before prepending link headers.
+		     */
+		    ether_type = ntohs(eh->ether_type);
+		    if (ether_type == ETHERTYPE_IP)
+			    af = AF_INET;
+#ifdef INET6
+		    else if (ether_type == ETHERTYPE_IPV6)
+			    af = AF_INET6;
+#endif
+		    else
+			    af = AF_UNSPEC;
+		    IFQ_CLASSIFY(&last->if_snd, m, af, &pktattr);
+	    }
+#endif /* ALTQ */
 	    /*
 	     * Add header (optimized for the common case of eh pointing
 	     * already into the mbuf) and execute last part of ether_output:
@@ -807,26 +837,26 @@
 		    return m0;
 		bcopy(&save_eh, mtod(m, struct ether_header *), ETHER_HDR_LEN);
 	    }
+	    mflags = m->m_flags;
+	    len = m->m_pkthdr.len;
 	    s = splimp();
-	    if (IF_QFULL(&last->if_snd)) {
-		IF_DROP(&last->if_snd);
-#if 0
-		BDG_MUTE(last); /* should I also mute ? */
+#ifdef ALTQ
+	    IFQ_ENQUEUE(&last->if_snd, m, &pktattr, error);
+#else
+	    IFQ_ENQUEUE(&last->if_snd, m, error);
 #endif
-		splx(s);
-		m_freem(m); /* consume the pkt anyways */
-	    } else {
-		last->if_obytes += m->m_pkthdr.len ;
-		if (m->m_flags & M_MCAST)
+	    if (error == 0) {
+		last->if_obytes += len;
+		if (mflags & M_MCAST)
 		    last->if_omcasts++;
 		if (m->m_pkthdr.len != m->m_len) /* this pkt is on >1 bufs */
 		    bdg_split_pkts++;
 
-		IF_ENQUEUE(&last->if_snd, m);
 		if ((last->if_flags & IFF_OACTIVE) == 0)
 		    (*last->if_start)(last);
-		splx(s);
 	    }
+	    splx(s);
+
 	    BDG_STAT(last, BDG_OUT);
 	    last = NULL ;
 	    if (once)
@@ -839,7 +869,10 @@
 	 * up and running, is not the source interface, and belongs to
 	 * the same cluster as the 'real_dst', then send here.
 	 */
-	if ( BDG_USED(ifp) && !BDG_MUTED(ifp) && !IF_QFULL(&ifp->if_snd)  &&
+	if ( BDG_USED(ifp) && !BDG_MUTED(ifp) &&
+#ifndef ALTQ
+	     !IF_QFULL(&ifp->if_snd)  &&
+#endif
 	     (ifp->if_flags & (IFF_UP|IFF_RUNNING)) == (IFF_UP|IFF_RUNNING) &&
 	     ifp != src && BDG_SAMECLUSTER(ifp, real_dst) )
 	    last = ifp ;
diff -urN ../sys/net/if.c ./net/if.c
--- ../sys/net/if.c	Wed Jul 25 04:10:17 2001
+++ ./net/if.c	Tue Oct  2 22:06:21 2001
@@ -76,7 +76,11 @@
 
 static int ifconf __P((u_long, caddr_t));
 static void ifinit __P((void *));
+#ifdef ALTQ
+static void if_qflush __P((struct ifaltq *));
+#else
 static void if_qflush __P((struct ifqueue *));
+#endif
 static void if_slowtimo __P((void *));
 static void link_rtrequest __P((int, struct rtentry *, struct sockaddr *));
 static int  if_rtdel __P((struct radix_node *, void *));
@@ -224,6 +228,13 @@
 			sdl->sdl_data[--namelen] = 0xff;
 		TAILQ_INSERT_HEAD(&ifp->if_addrhead, ifa, ifa_link);
 	}
+#ifdef ALTQ
+	ifp->if_snd.altq_type = 0;
+	ifp->if_snd.altq_disc = NULL;
+	ifp->if_snd.altq_flags &= ALTQF_CANTCHANGE;
+	ifp->if_snd.altq_tbr  = NULL;
+	ifp->if_snd.altq_ifp  = ifp;
+#endif
 }
 
 /*
@@ -244,6 +255,12 @@
 	 */
 	s = splnet();
 	if_down(ifp);
+#ifdef ALTQ
+	if (ALTQ_IS_ENABLED(&ifp->if_snd))
+		altq_disable(&ifp->if_snd);
+	if (ALTQ_IS_ATTACHED(&ifp->if_snd))
+		altq_detach(&ifp->if_snd);
+#endif
 
 	/*
 	 * Remove address from ifnet_addrs[] and maybe decrement if_index.
@@ -823,10 +840,18 @@
  */
 static void
 if_qflush(ifq)
+#ifdef ALTQ
+	struct ifaltq *ifq;
+#else
 	register struct ifqueue *ifq;
+#endif
 {
 	register struct mbuf *m, *n;
 
+#ifdef ALTQ
+	if (ALTQ_IS_ENABLED(ifq))
+		ALTQ_PURGE(ifq);
+#endif
 	n = ifq->ifq_head;
 	while ((m = n) != 0) {
 		n = m->m_act;
diff -urN ../sys/net/if_atm.h ./net/if_atm.h
--- ../sys/net/if_atm.h	Wed Dec 29 13:38:34 1999
+++ ./net/if_atm.h	Tue Oct  2 22:06:21 2001
@@ -37,6 +37,14 @@
  * net/if_atm.h
  */
 
+#ifndef NO_ATM_PVCEXT
+/*
+ * ATM_PVCEXT enables PVC extention: VP/VC shaping
+ * and PVC shadow interfaces.
+ */
+#define ATM_PVCEXT	/* enable pvc extention */
+#endif
+
 #if defined(__NetBSD__) || defined(__OpenBSD__) || defined(__bsdi__)
 #define RTALLOC1(A,B)		rtalloc1((A),(B))
 #elif defined(__FreeBSD__)
@@ -61,6 +69,9 @@
 #define ATM_PH_AAL5    0x01	/* use AAL5? (0 == aal0) */
 #define ATM_PH_LLCSNAP 0x02	/* use the LLC SNAP encoding (iff aal5) */
 
+#ifdef ATM_PVCEXT
+#define ATM_PH_INERNAL  0x20	/* reserve for kernel internal use */
+#endif
 #define ATM_PH_DRIVER7  0x40	/* reserve for driver's use */
 #define ATM_PH_DRIVER8  0x80	/* reserve for driver's use */
 
@@ -79,6 +90,35 @@
 #define SIOCATMENA	_IOWR('a', 123, struct atm_pseudoioctl) /* enable */
 #define SIOCATMDIS	_IOWR('a', 124, struct atm_pseudoioctl) /* disable */
 
+#ifdef ATM_PVCEXT
+
+/* structure to control PVC transmitter */
+struct pvctxreq {
+    /* first entry must be compatible with struct ifreq */
+    char pvc_ifname[IFNAMSIZ];		/* if name, e.g. "en0" */
+    struct atm_pseudohdr pvc_aph;	/* (flags) + vpi:vci */
+    struct atm_pseudohdr pvc_joint;	/* for vp shaping: another vc
+					   to share the shaper */
+    int pvc_pcr;			/* peak cell rate (shaper value) */
+};
+
+/* structure to control PVC bridging */
+struct pvcfwdreq {
+    /* first entry must be compatible with struct ifreq */
+    char pvc_ifname[IFNAMSIZ];		/* if name, e.g. "en0" */
+    char pvc_ifname2[IFNAMSIZ];		/* if name to be bridged to/from */
+    int	 pvc_op;			/* 1:add 0:delete */
+};
+
+/* use ifioctl for now */
+#define SIOCSPVCFWD	_IOW('i', 93, struct pvcfwdreq)
+#define SIOCGPVCFWD	_IOWR('i', 94, struct pvcfwdreq)
+#define SIOCSPVCTX	_IOWR('i', 95, struct pvctxreq)
+#define SIOCGPVCTX	_IOWR('i', 96, struct pvctxreq)
+#define SIOCSPVCSIF	_IOWR('i', 97, struct ifreq)
+#define SIOCGPVCSIF	_IOWR('i', 98, struct ifreq)
+
+#endif /* ATM_PVCEXT */
 
 /*
  * XXX forget all the garbage in if_llc.h and do it the easy way
@@ -105,3 +145,28 @@
 		struct rtentry *));
 #endif
 
+#ifdef ATM_PVCEXT
+#ifdef _KERNEL
+#include <sys/queue.h>
+/*
+ * ATM PVC subinterface: a trick to assign a subinterface
+ * to a PVC.
+ * with a pvc subinterface, each PVC looks like an individual
+ * Point-to-Point interface.
+ * as opposed to the NBMA model, a pvc subinterface is inherently
+ * multicast capable (no LANE/MARS required).
+ */
+struct pvcsif {
+	/*
+	 * The ifnet struct _must_ be at the head of this structure.
+	 */
+	struct ifnet sif_if;		/* ifnet structure per pvc */
+	struct atm_pseudohdr sif_aph;	/* flags + vpi:vci */
+	int	sif_vci;		/* vci no */
+	struct ifnet *sif_fwdifp;	/* bridging ifp */
+	LIST_ENTRY(pvcsif) sif_links;
+};
+struct ifnet *pvcsif_alloc __P((void));
+int pvc_set_fwd __P((char *, char *, int));
+#endif
+#endif /* ATM_PVCEXT */
diff -urN ../sys/net/if_atmsubr.c ./net/if_atmsubr.c
--- ../sys/net/if_atmsubr.c	Tue Mar  6 09:29:26 2001
+++ ./net/if_atmsubr.c	Tue Oct  2 22:06:21 2001
@@ -47,6 +47,7 @@
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/sockio.h>
+#include <sys/malloc.h>
 #include <sys/errno.h>
 
 #include <net/if.h>
@@ -95,17 +96,28 @@
 	struct rtentry *rt0;
 {
 	u_int16_t etype = 0;			/* if using LLC/SNAP */
-	int s, error = 0, sz;
+	int s, error = 0, sz, len;
 	struct atm_pseudohdr atmdst, *ad;
 	struct mbuf *m = m0;
 	struct rtentry *rt;
 	struct atmllc *atmllc;
 	struct atmllc *llc_hdr = NULL;
 	u_int32_t atm_flags;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING))
 		senderr(ENETDOWN);
 
+#ifdef ALTQ
+	/*
+	 * if the queueing discipline needs packet classification,
+	 * do it before prepending link headers.
+	 */
+	IFQ_CLASSIFY(&ifp->if_snd, m,
+		     (dst != NULL ? dst->sa_family : AF_UNSPEC), &pktattr);
+#endif
 	/*
 	 * check route
 	 */
@@ -139,12 +151,24 @@
 	if (dst) {
 		switch (dst->sa_family) {
 #if defined(INET) || defined(INET6)
+#ifdef INET
 		case AF_INET:
+#endif
+#ifdef INET6
 		case AF_INET6:
+#endif
 			if (dst->sa_family == AF_INET6)
 			        etype = htons(ETHERTYPE_IPV6);
 			else
 			        etype = htons(ETHERTYPE_IP);
+#ifdef ATM_PVCEXT
+			if (ifp->if_flags & IFF_POINTOPOINT) {
+				/* pvc subinterface */
+				struct pvcsif *pvcsif = (struct pvcsif *)ifp;
+				atmdst = pvcsif->sif_aph;
+				break;
+			}
+#endif
 			if (!atmresolve(rt, m, dst, &atmdst)) {
 				m = NULL; 
 				/* XXX: atmresolve already free'd it */
@@ -203,14 +227,18 @@
 	 * Queue message on interface, and start output if interface
 	 * not yet active.
 	 */
+	len = m->m_pkthdr.len;
 	s = splimp();
-	if (IF_QFULL(&ifp->if_snd)) {
-		IF_DROP(&ifp->if_snd);
+#ifdef ALTQ
+	IFQ_ENQUEUE(&ifp->if_snd, m, &pktattr, error);
+#else
+	IFQ_ENQUEUE(&ifp->if_snd, m, error);
+#endif
+	if (error) {
 		splx(s);
-		senderr(ENOBUFS);
+		return (error);
 	}
-	ifp->if_obytes += m->m_pkthdr.len;
-	IF_ENQUEUE(&ifp->if_snd, m);
+	ifp->if_obytes += len;
 	if ((ifp->if_flags & IFF_OACTIVE) == 0)
 		(*ifp->if_start)(ifp);
 	splx(s);
@@ -282,6 +310,33 @@
 			m_adj(m, sizeof(*alc));
 		}
 
+#ifdef ATM_PVCEXT
+		/* atm bridging support */
+		if ((ifp->if_flags & (IFF_POINTOPOINT|IFF_LINK2)) ==
+		    (IFF_POINTOPOINT|IFF_LINK2)) {
+			struct pvcsif *pvcsif = (struct pvcsif *)ifp;
+
+			if (pvcsif->sif_fwdifp != NULL) {
+				struct sockaddr dst;
+
+				/* set address family to dummy dst addr */
+				switch (etype) {
+				case ETHERTYPE_IP:
+					dst.sa_family = AF_INET;
+					break;
+				case ETHERTYPE_IPV6:
+					dst.sa_family = AF_INET6;
+					break;
+				default:
+					m_freem(m);
+					return;
+				}
+				atm_output(pvcsif->sif_fwdifp, m, &dst, NULL);
+				return;
+			}
+		}
+#endif /* ATM_PVCEXT */
+
 		switch (etype) {
 #ifdef INET
 		case ETHERTYPE_IP:
@@ -325,7 +380,7 @@
 	ifp->if_hdrlen = 0;
 	ifp->if_mtu = ATMMTU;
 	ifp->if_output = atm_output;
-	ifp->if_snd.ifq_maxlen = 50;	/* dummy */
+	IFQ_SET_MAXLEN(&ifp->if_snd, 50);	/* dummy */
 
 #if defined(__NetBSD__) || defined(__OpenBSD__)
 	for (ifa = TAILQ_FIRST(&ifp->if_addrlist); ifa != 0;
@@ -347,3 +402,86 @@
 		}
 
 }
+
+#ifdef ATM_PVCEXT
+
+static int pvc_max_number = 16;	/* max number of PVCs */
+static int pvc_number = 0;	/* pvc unit number */
+
+struct ifnet *
+pvcsif_alloc()
+{
+	struct pvcsif *pvcsif;
+
+	if (pvc_number >= pvc_max_number)
+		return (NULL);
+	MALLOC(pvcsif, struct pvcsif *, sizeof(struct pvcsif),
+	       M_DEVBUF, M_WAITOK);
+	if (pvcsif == NULL)
+		return (NULL);
+	bzero(pvcsif, sizeof(struct pvcsif));
+
+#ifdef __NetBSD__
+	sprintf(pvcsif->sif_if.if_xname, "pvc%d", pvc_number++);
+#else
+	pvcsif->sif_if.if_name = "pvc";
+	pvcsif->sif_if.if_unit = pvc_number++;
+#endif
+	return (&pvcsif->sif_if);
+}
+
+/*
+ * pvc bridging support:
+ * add or delete brigding between 2 pvc interfaces.
+ */
+int
+pvc_set_fwd(if_name, if_name2, op)
+	char *if_name, *if_name2;
+	int op;		/* 0:delete 1:add 2:get */
+{
+	struct ifnet *ifp, *ifp2;
+	struct pvcsif *pvcsif, *pvcsif2;
+
+	if (strncmp(if_name, "pvc", 3) != 0
+	    || (ifp = ifunit(if_name)) == NULL)
+		return (EINVAL);
+	pvcsif = (struct pvcsif *)ifp;
+
+	if (op == 2) {
+		/* get bridging info */
+		if ((ifp2 = pvcsif->sif_fwdifp) == NULL)
+			*if_name2 = '\0';
+		else
+#ifdef __NetBSD__
+			sprintf(if_name2, "%s", ifp2->if_xname);
+#else
+			sprintf(if_name2, "%s%d",
+				ifp2->if_name, ifp2->if_unit);
+#endif
+		return (0);
+	}
+
+	if (strncmp(if_name2, "pvc", 3) != 0
+	    || (ifp2 = ifunit(if_name2)) == NULL)
+		return (EINVAL);
+	pvcsif2 = (struct pvcsif *)ifp2;
+
+	if (op) {
+		/* set up bridging */
+		pvcsif->sif_fwdifp = ifp2;
+		pvcsif2->sif_fwdifp = ifp;
+		ifp->if_flags |= IFF_LINK2;	/* use IFF_LINK2 to show */
+		ifp2->if_flags |= IFF_LINK2;	/* bridging is enabled   */
+	}
+	else {
+		/* delete bridging */
+		if (pvcsif->sif_fwdifp != ifp2 || pvcsif2->sif_fwdifp != ifp)
+			return (EINVAL);
+		pvcsif->sif_fwdifp = NULL;
+		pvcsif2->sif_fwdifp = NULL;
+		ifp->if_flags &= ~IFF_LINK2;
+		ifp2->if_flags &= ~IFF_LINK2;
+	}
+	return (0);
+}
+#endif /* ATM_PVCEXT */
diff -urN ../sys/net/if_ethersubr.c ./net/if_ethersubr.c
--- ../sys/net/if_ethersubr.c	Wed Aug  1 09:47:49 2001
+++ ./net/if_ethersubr.c	Tue Oct  2 22:06:21 2001
@@ -364,7 +364,11 @@
 	struct ifnet *ifp;
 	struct mbuf *m;
 {
-	int s, error = 0;
+	int s, len, error = 0;
+	short mflags;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 #ifdef BRIDGE
 	if (do_bridge && BDG_USED(ifp) ) {
@@ -379,22 +383,30 @@
 		return (0);
 	}
 #endif
-
+#ifdef ALTQ
+	if (ALTQ_IS_ENABLED(&ifp->if_snd))
+		altq_etherclassify(&ifp->if_snd, m, &pktattr);
+#endif
+	mflags = m->m_flags;
+	len = m->m_pkthdr.len;
 	s = splimp();
 	/*
 	 * Queue message on interface, and start output if interface
 	 * not yet active.
 	 */
-	if (IF_QFULL(&ifp->if_snd)) {
-		IF_DROP(&ifp->if_snd);
+#ifdef ALTQ
+	IFQ_ENQUEUE(&ifp->if_snd, m, &pktattr, error);
+#else
+	IFQ_ENQUEUE(&ifp->if_snd, m, error);
+#endif
+	if (error) {
+		/* mbuf is already freed */
 		splx(s);
-		m_freem(m);
-		return (ENOBUFS);
+		return (error);
 	}
-	ifp->if_obytes += m->m_pkthdr.len;
-	if (m->m_flags & M_MCAST)
+	ifp->if_obytes += len;
+	if (mflags & M_MCAST)
 		ifp->if_omcasts++;
-	IF_ENQUEUE(&ifp->if_snd, m);
 	if ((ifp->if_flags & IFF_OACTIVE) == 0)
 		(*ifp->if_start)(ifp);
 	splx(s);
@@ -899,3 +911,79 @@
 	}
 }
 
+#ifdef ALTQ
+/*
+ * find the size of ethernet header, and call classifier
+ */
+int
+altq_etherclassify(ifq, m, pktattr)
+	struct ifaltq *ifq;
+	struct mbuf *m;
+	struct altq_pktattr *pktattr;
+{
+	struct ether_header *eh;
+	u_short	ether_type;
+	int	hlen, af, hdrsize;
+	caddr_t hdr;
+
+	hlen = sizeof(struct ether_header);
+	eh = mtod(m, struct ether_header *);
+
+	ether_type = ntohs(eh->ether_type);
+	if (ether_type < ETHERMTU) {
+		/* ick! LLC/SNAP */
+		struct llc *llc = (struct llc *)(eh + 1);
+		hlen += 8;
+
+		if (m->m_len < hlen ||
+		    llc->llc_dsap != LLC_SNAP_LSAP ||
+		    llc->llc_ssap != LLC_SNAP_LSAP ||
+		    llc->llc_control != LLC_UI)
+			goto bad;  /* not snap! */
+
+		ether_type = ntohs(llc->llc_un.type_snap.ether_type);
+	}
+
+	if (ether_type == ETHERTYPE_IP) {
+		af = AF_INET;
+		hdrsize = 20;  /* sizeof(struct ip) */
+#ifdef INET6
+	} else if (ether_type == ETHERTYPE_IPV6) {
+		af = AF_INET6;
+		hdrsize = 40;  /* sizeof(struct ip6_hdr) */
+#endif
+	} else
+		goto bad;
+
+	while (m->m_len <= hlen) {
+		hlen -= m->m_len;
+		m = m->m_next;
+	}
+	hdr = m->m_data + hlen;
+	if (m->m_len < hlen + hdrsize) {
+		/*
+		 * ip header is not in a single mbuf.  this should not
+		 * happen in the current code.
+		 * (todo: use m_pulldown in the future)
+		 */
+		goto bad;
+	}
+	m->m_data += hlen;
+	m->m_len -= hlen;
+	if (ALTQ_NEEDS_CLASSIFY(ifq))
+		pktattr->pattr_class =
+		    (*ifq->altq_classify)(ifq->altq_clfier, m, af);
+	m->m_data -= hlen;
+	m->m_len += hlen;
+
+	pktattr->pattr_af = af;
+	pktattr->pattr_hdr = hdr;
+	return (1);
+
+bad:
+	pktattr->pattr_class = NULL;
+	pktattr->pattr_hdr = NULL;
+	pktattr->pattr_af = AF_UNSPEC;
+	return (0);
+}
+#endif /* ALTQ */
diff -urN ../sys/net/if_loop.c ./net/if_loop.c
--- ../sys/net/if_loop.c	Tue Jul  3 20:01:41 2001
+++ ./net/if_loop.c	Tue Oct  2 22:06:21 2001
@@ -90,6 +90,9 @@
 static void lortrequest __P((int, struct rtentry *, struct sockaddr *));
 
 static void loopattach __P((void *));
+#ifdef ALTQ
+static void lo_altqstart __P((struct ifnet *));
+#endif
 PSEUDO_SET(loopattach, if_loop);
 
 int looutput __P((struct ifnet *ifp,
@@ -121,7 +124,11 @@
 	    ifp->if_ioctl = loioctl;
 	    ifp->if_output = looutput;
 	    ifp->if_type = IFT_LOOP;
-	    ifp->if_snd.ifq_maxlen = ifqmaxlen;
+	    IFQ_SET_MAXLEN(&ifp->if_snd, ifqmaxlen);
+	    IFQ_SET_READY(&ifp->if_snd);
+#ifdef ALTQ
+	    ifp->if_start = lo_altqstart;
+#endif
 	    if_attach(ifp);
 	    bpfattach(ifp, DLT_NULL, sizeof(u_int));
 	}
@@ -262,6 +269,38 @@
 #endif
 	}
 
+#ifdef ALTQ
+	/*
+	 * altq for loop is just for debugging.
+	 * only used when called for loop interface (not for
+	 * a simplex interface).
+	 */
+	if ((ALTQ_IS_ENABLED(&ifp->if_snd) || TBR_IS_ENABLED(&ifp->if_snd))
+	    && ifp->if_start == lo_altqstart) {
+		struct altq_pktattr pktattr;
+		int32_t *afp;
+	        int error;
+
+		/*
+		 * if the queueing discipline needs packet classification,
+		 * do it before prepending link headers.
+		 */
+		IFQ_CLASSIFY(&ifp->if_snd, m, af, &pktattr);
+
+		M_PREPEND(m, sizeof(int32_t), M_DONTWAIT);
+		if (m == 0)
+			return(ENOBUFS);
+		afp = mtod(m, int32_t *);
+		*afp = (int32_t)af;
+
+	        s = splimp();
+		IFQ_ENQUEUE(&ifp->if_snd, m, &pktattr, error);
+		(*ifp->if_start)(ifp);
+		splx(s);
+		return (error);
+	}
+#endif /* ALTQ */
+
 	/* Deliver to upper layer protocol */
 	switch (af) {
 #ifdef INET
@@ -314,6 +353,87 @@
 	splx(s);
 	return (0);
 }
+
+#ifdef ALTQ
+static void
+lo_altqstart(ifp)
+	struct ifnet *ifp;
+{
+	struct ifqueue *ifq;
+	struct mbuf *m;
+	int32_t af, *afp;
+	int s, isr;
+	
+	while (1) {
+		s = splimp();
+		IFQ_DEQUEUE(&ifp->if_snd, m);
+		splx(s);
+		if (m == NULL)
+			return;
+
+		afp = mtod(m, int32_t *);
+		af = *afp;
+		m_adj(m, sizeof(int32_t));
+
+		switch (af) {
+#ifdef INET
+		case AF_INET:
+			ifq = &ipintrq;
+			isr = NETISR_IP;
+			break;
+#endif
+#ifdef INET6
+		case AF_INET6:
+			m->m_flags |= M_LOOP;
+			ifq = &ip6intrq;
+			isr = NETISR_IPV6;
+			break;
+#endif
+#ifdef IPX
+		case AF_IPX:
+			ifq = &ipxintrq;
+			isr = NETISR_IPX;
+			break;
+#endif
+#ifdef NS
+		case AF_NS:
+			ifq = &nsintrq;
+			isr = NETISR_NS;
+			break;
+#endif
+#ifdef ISO
+		case AF_ISO:
+			ifq = &clnlintrq;
+			isr = NETISR_ISO;
+			break;
+#endif
+#ifdef NETATALK
+		case AF_APPLETALK:
+			ifq = &atintrq2;
+			isr = NETISR_ATALK;
+			break;
+#endif NETATALK
+		default:
+			printf("lo_altqstart: can't handle af%d\n", af);
+			m_freem(m);
+			return;
+		}
+
+		s = splimp();
+		if (IF_QFULL(ifq)) {
+			IF_DROP(ifq);
+			m_freem(m);
+			splx(s);
+			return;
+		}
+		IF_ENQUEUE(ifq, m);
+		schednetisr(isr);
+		ifp->if_ipackets++;
+		ifp->if_ibytes += m->m_pkthdr.len;
+		splx(s);
+	}
+}
+#endif /* ALTQ */
 
 /* ARGSUSED */
 static void
diff -urN ../sys/net/if_ppp.c ./net/if_ppp.c
--- ../sys/net/if_ppp.c	Tue Sep 11 18:49:54 2001
+++ ./net/if_ppp.c	Tue Oct  2 22:06:21 2001
@@ -207,10 +207,11 @@
 	sc->sc_if.if_hdrlen = PPP_HDRLEN;
 	sc->sc_if.if_ioctl = pppsioctl;
 	sc->sc_if.if_output = pppoutput;
-	sc->sc_if.if_snd.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_MAXLEN(&sc->sc_if.if_snd, IFQ_MAXLEN);
 	sc->sc_inq.ifq_maxlen = IFQ_MAXLEN;
 	sc->sc_fastq.ifq_maxlen = IFQ_MAXLEN;
 	sc->sc_rawq.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_READY(&sc->sc_if.if_snd);
 	if_attach(&sc->sc_if);
 	bpfattach(&sc->sc_if, DLT_PPP, PPP_HDRLEN);
     }
@@ -693,6 +694,9 @@
     enum NPmode mode;
     int len;
     struct mbuf *m;
+#ifdef ALTQ
+    struct altq_pktattr pktattr;
+#endif
 
     if (sc->sc_devp == NULL || (ifp->if_flags & IFF_RUNNING) == 0
 	|| ((ifp->if_flags & IFF_UP) == 0 && dst->sa_family != AF_UNSPEC)) {
@@ -700,6 +704,9 @@
 	goto bad;
     }
 
+#ifdef ALTQ
+    IFQ_CLASSIFY(&ifp->if_snd, m0, dst->sa_family, &pktattr);
+#endif
     /*
      * Compute PPP header.
      */
@@ -835,16 +842,34 @@
 	sc->sc_npqtail = &m0->m_nextpkt;
     } else {
 	/* fastq and if_snd are emptied at spl[soft]net now */
-	ifq = (m0->m_flags & M_HIGHPRI)? &sc->sc_fastq: &ifp->if_snd;
-	if (IF_QFULL(ifq) && dst->sa_family != AF_UNSPEC) {
-	    IF_DROP(ifq);
+	if ((m0->m_flags & M_HIGHPRI)
+#ifdef ALTQ
+	    && !ALTQ_IS_ENABLED(&sc->sc_if.if_snd)
+#endif
+	    ) {
+	    ifq = &sc->sc_fastq;
+	    if (IF_QFULL(ifq) && dst->sa_family != AF_UNSPEC) {
+		IF_DROP(ifq);
+		m_freem(m0);
+		error = ENOBUFS;
+	    }
+	    else {
+		IF_ENQUEUE(ifq, m0);
+		error = 0;
+	    }
+	} else {
+#ifdef ALTQ
+	    IFQ_ENQUEUE(&sc->sc_if.if_snd, m0, &pktattr, error);
+#else
+	    IFQ_ENQUEUE(&sc->sc_if.if_snd, m0, error);
+#endif
+	}
+	if (error) {
 	    splx(s);
 	    sc->sc_if.if_oerrors++;
 	    sc->sc_stats.ppp_oerrors++;
-	    error = ENOBUFS;
-	    goto bad;
+	    return (error);
 	}
-	IF_ENQUEUE(ifq, m0);
 	(*sc->sc_start)(sc);
     }
     getmicrotime(&ifp->if_lastchange);
@@ -871,6 +896,7 @@
     struct mbuf *m, **mpp;
     struct ifqueue *ifq;
     enum NPmode mode;
+    int error;
 
     for (mpp = &sc->sc_npqueue; (m = *mpp) != NULL; ) {
 	switch (PPP_PROTOCOL(mtod(m, u_char *))) {
@@ -888,13 +914,32 @@
 	     */
 	    *mpp = m->m_nextpkt;
 	    m->m_nextpkt = NULL;
-	    ifq = (m->m_flags & M_HIGHPRI)? &sc->sc_fastq: &sc->sc_if.if_snd;
-	    if (IF_QFULL(ifq)) {
-		IF_DROP(ifq);
+	    if ((m->m_flags & M_HIGHPRI)
+#ifdef ALTQ
+		&& !ALTQ_IS_ENABLED(&sc->sc_if.if_snd)
+#endif
+		) {
+		ifq = &sc->sc_fastq;
+		if (IF_QFULL(ifq)) {
+		    IF_DROP(ifq);
+		    m_freem(m);
+		    error = ENOBUFS;
+		}
+		else {
+		    IF_ENQUEUE(ifq, m);
+		    error = 0;
+		}
+	    } else {
+#ifdef ALTQ
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, NULL, error);
+#else
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, error);
+#endif
+	    }
+	    if (error) {
 		sc->sc_if.if_oerrors++;
 		sc->sc_stats.ppp_oerrors++;
-	    } else
-		IF_ENQUEUE(ifq, m);
+	    }
 	    break;
 
 	case NPMODE_DROP:
@@ -947,7 +992,7 @@
      */
     IF_DEQUEUE(&sc->sc_fastq, m);
     if (m == NULL)
-	IF_DEQUEUE(&sc->sc_if.if_snd, m);
+	IFQ_DEQUEUE(&sc->sc_if.if_snd, m);
     if (m == NULL)
 	return NULL;
 
@@ -1072,7 +1117,7 @@
     for (i = 0; i < NPPP; ++i, ++sc) {
 	s = splimp();
 	if (!(sc->sc_flags & SC_TBUSY)
-	    && (sc->sc_if.if_snd.ifq_head || sc->sc_fastq.ifq_head)) {
+	    && (!IFQ_IS_EMPTY(&sc->sc_if.if_snd) || sc->sc_fastq.ifq_head)) {
 	    sc->sc_flags |= SC_TBUSY;
 	    splx(s);
 	    (*sc->sc_start)(sc);
diff -urN ../sys/net/if_sl.c ./net/if_sl.c
--- ../sys/net/if_sl.c	Tue Dec 26 11:22:57 2000
+++ ./net/if_sl.c	Tue Oct  2 22:06:21 2001
@@ -223,10 +223,11 @@
 		sc->sc_if.if_type = IFT_SLIP;
 		sc->sc_if.if_ioctl = slioctl;
 		sc->sc_if.if_output = sloutput;
-		sc->sc_if.if_snd.ifq_maxlen = 50;
+		IFQ_SET_MAXLEN(&sc->sc_if.if_snd, 50);
 		sc->sc_fastq.ifq_maxlen = 32;
 		sc->sc_if.if_linkmib = sc;
 		sc->sc_if.if_linkmiblen = sizeof *sc;
+		IFQ_SET_READY(&sc->sc_if.if_snd);
 		if_attach(&sc->sc_if);
 		bpfattach(&sc->sc_if, DLT_SLIP, SLIP_HDRLEN);
 	}
@@ -489,8 +490,14 @@
 	register struct sl_softc *sc = &sl_softc[ifp->if_unit];
 	register struct ip *ip;
 	register struct ifqueue *ifq;
-	int s;
+	int s, error;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
+#ifdef ALTQ
+	IFQ_CLASSIFY(&ifp->if_snd, m, dst->sa_family, &pktattr);
+#endif
 	/*
 	 * `Cannot happen' (see slioctl).  Someday we will extend
 	 * the line protocol to support other address families.
@@ -511,23 +518,38 @@
 		m_freem(m);
 		return (EHOSTUNREACH);
 	}
-	ifq = &sc->sc_if.if_snd;
 	ip = mtod(m, struct ip *);
 	if (sc->sc_if.if_flags & SC_NOICMP && ip->ip_p == IPPROTO_ICMP) {
 		m_freem(m);
 		return (ENETRESET);		/* XXX ? */
 	}
-	if (ip->ip_tos & IPTOS_LOWDELAY)
-		ifq = &sc->sc_fastq;
 	s = splimp();
-	if (IF_QFULL(ifq)) {
-		IF_DROP(ifq);
-		m_freem(m);
+	if ((ip->ip_tos & IPTOS_LOWDELAY)
+#ifdef ALTQ
+	    && !ALTQ_IS_ENABLED(&sc->sc_if.if_snd)
+#endif
+		) {
+		ifq = &sc->sc_fastq;
+		if (IF_QFULL(ifq)) {
+			IF_DROP(ifq);
+			m_freem(m);
+			error = ENOBUFS;
+		} else {
+			IF_ENQUEUE(ifq, m);
+			error = 0;
+		}
+	} else {
+#ifdef ALTQ
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, &pktattr, error);
+#else
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, error);
+#endif
+	}
+	if (error) {
 		splx(s);
 		sc->sc_if.if_oerrors++;
-		return (ENOBUFS);
+		return (error);
 	}
-	IF_ENQUEUE(ifq, m);
 	if (sc->sc_ttyp->t_outq.c_cc == 0)
 		slstart(sc->sc_ttyp);
 	splx(s);
@@ -581,7 +603,7 @@
 		if (m)
 			sc->sc_if.if_omcasts++;		/* XXX */
 		else
-			IF_DEQUEUE(&sc->sc_if.if_snd, m);
+			IFQ_DEQUEUE(&sc->sc_if.if_snd, m);
 		splx(s);
 		if (m == NULL)
 			return 0;
diff -urN ../sys/net/if_spppsubr.c ./net/if_spppsubr.c
--- ../sys/net/if_spppsubr.c	Wed Aug  1 04:43:55 2001
+++ ./net/if_spppsubr.c	Tue Oct  2 22:13:12 2001
@@ -697,7 +697,7 @@
 	struct sppp *sp = (struct sppp*) ifp;
 	struct ppp_header *h;
 	struct ifqueue *ifq = NULL;
-	int s, rv = 0;
+	int s, len, rv = 0;
 	int debug = ifp->if_flags & IFF_DEBUG;
 
 	s = splimp();
@@ -720,7 +720,13 @@
 		s = splimp();
 	}
 
-	ifq = &ifp->if_snd;
+#ifdef ALTQ
+	/*
+	 * if the queueing discipline needs packet classification,
+	 * do it before prepending link headers.
+	 */
+	IFQ_CLASSIFY(&ifp->if_snd, m, dst->sa_family, &pktattr);
+#endif
 #ifdef INET
 	if (dst->sa_family == AF_INET) {
 		/* XXX Check mbuf length here? */
@@ -773,6 +779,12 @@
 	}
 #endif
 
+#ifdef INET6
+        if (dst->sa_family == AF_INET6) {
+                /* XXX do something tricky here? */
+        }
+#endif
+
 	/*
 	 * Prepend general data packet PPP header. For now, IP only.
 	 */
@@ -863,14 +875,33 @@
 	 * Queue message on interface, and start output if interface
 	 * not yet active.
 	 */
-	if (IF_QFULL (ifq)) {
-		IF_DROP (&ifp->if_snd);
-		m_freem (m);
+	len = m->m_pkthdr.len;
+	if (ifq != NULL
+#ifdef ALTQ
+	    && !ALTQ_IS_ENABLED(&ifp->if_snd)
+#endif
+		) {
+		if (IF_QFULL (ifq)) {
+			IF_DROP (&ifp->if_snd);
+			m_freem (m);
+			if (rv == 0)
+				rv = ENOBUFS;
+		}
+		IF_ENQUEUE (ifq, m);
+	}
+	else {
+#ifdef ALTQ
+		IFQ_ENQUEUE(&ifp->if_snd, m, &pktattr, rv);
+#else
+		IFQ_ENQUEUE(&ifp->if_snd, m, rv);
+#endif
+	}
+	if (rv != 0) {
 		++ifp->if_oerrors;
 		splx (s);
-		return (rv? rv: ENOBUFS);
+		return (rv);
 	}
-	IF_ENQUEUE (ifq, m);
+
 	if (! (ifp->if_flags & IFF_OACTIVE))
 		(*ifp->if_start) (ifp);
 
@@ -879,7 +910,7 @@
 	 * The packet length includes header, FCS and 1 flag,
 	 * according to RFC 1333.
 	 */
-	ifp->if_obytes += m->m_pkthdr.len + 3;
+	ifp->if_obytes += len + 3;
 	splx (s);
 	return (0);
 }
@@ -952,7 +983,7 @@
 {
 	struct sppp *sp = (struct sppp*) ifp;
 
-	sppp_qflush (&sp->pp_if.if_snd);
+	IFQ_PURGE(&sp->pp_if.if_snd);
 	sppp_qflush (&sp->pp_fastq);
 	sppp_qflush (&sp->pp_cpq);
 }
@@ -968,7 +999,7 @@
 
 	s = splimp();
 	empty = !sp->pp_fastq.ifq_head && !sp->pp_cpq.ifq_head &&
-		!sp->pp_if.if_snd.ifq_head;
+		IFQ_IS_EMPTY(&sp->pp_if.if_snd);
 	splx(s);
 	return (empty);
 }
@@ -995,7 +1026,7 @@
 	    (sppp_ncp_check(sp) || sp->pp_mode == IFF_CISCO)) {
 		IF_DEQUEUE(&sp->pp_fastq, m);
 		if (m == NULL)
-			IF_DEQUEUE (&sp->pp_if.if_snd, m);
+			IFQ_DEQUEUE (&sp->pp_if.if_snd, m);
 	}
 	splx(s);
 	return m;
@@ -1017,7 +1048,7 @@
 	if (m == NULL &&
 	    (sp->pp_phase == PHASE_NETWORK || sp->pp_mode == IFF_CISCO))
 		if ((m = sp->pp_fastq.ifq_head) == NULL)
-			m = sp->pp_if.if_snd.ifq_head;
+			IFQ_POLL(&sp->pp_if.if_snd, m);
 	splx (s);
 	return (m);
 }
diff -urN ../sys/net/if_tun.c ./net/if_tun.c
--- ../sys/net/if_tun.c	Wed Aug  8 22:07:00 2001
+++ ./net/if_tun.c	Tue Oct  2 22:06:21 2001
@@ -65,6 +65,9 @@
 	    struct rtentry *rt));
 static int tunifioctl __P((struct ifnet *, u_long, caddr_t));
 static int tuninit __P((struct ifnet *));
+#ifdef ALTQ
+static void tunstart __P((struct ifnet *));
+#endif
 
 static	d_open_t	tunopen;
 static	d_close_t	tunclose;
@@ -119,9 +122,13 @@
 	ifp->if_mtu = TUNMTU;
 	ifp->if_ioctl = tunifioctl;
 	ifp->if_output = tunoutput;
+#ifdef ALTQ
+	ifp->if_start = tunstart;
+#endif
 	ifp->if_flags = IFF_POINTOPOINT | IFF_MULTICAST;
 	ifp->if_type = IFT_PPP;
-	ifp->if_snd.ifq_maxlen = ifqmaxlen;
+	IFQ_SET_MAXLEN(&ifp->if_snd, ifqmaxlen);
+	IFQ_SET_READY(&ifp->if_snd);
 	ifp->if_softc = sc;
 	if_attach(ifp);
 	bpfattach(ifp, DLT_NULL, sizeof(u_int));
@@ -174,7 +181,6 @@
 	register int	s;
 	struct tun_softc *tp;
 	struct ifnet	*ifp;
-	struct mbuf	*m;
 
 	tp = dev->si_drv1;
 	ifp = &tp->tun_if;
@@ -185,13 +191,9 @@
 	/*
 	 * junk all pending output
 	 */
-	do {
-		s = splimp();
-		IF_DEQUEUE(&ifp->if_snd, m);
-		splx(s);
-		if (m)
-			m_freem(m);
-	} while (m);
+	s = splimp();
+	IFQ_PURGE(&ifp->if_snd);
+	splx(s);
 
 	if (ifp->if_flags & IFF_UP) {
 		s = splimp();
@@ -315,7 +317,10 @@
 	struct rtentry *rt;
 {
 	struct tun_softc *tp = ifp->if_softc;
-	int		s;
+	int		s, error, len;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 	TUNDEBUG ("%s%d: tunoutput\n", ifp->if_name, ifp->if_unit);
 
@@ -326,6 +331,13 @@
 		return EHOSTDOWN;
 	}
 
+#ifdef ALTQ
+	/*
+	 * if the queueing discipline needs packet classification,
+	 * do it before prepending link headers.
+	 */
+	IFQ_CLASSIFY(&ifp->if_snd, m0, dst->sa_family, &pktattr);
+#endif
 	/* BPF write needs to be handled specially */
 	if (dst->sa_family == AF_UNSPEC) {
 		dst->sa_family = *(mtod(m0, int *));
@@ -392,16 +404,19 @@
 		}
 	}
 
+	len = m0->m_pkthdr.len;
 	s = splimp();
-	if (IF_QFULL(&ifp->if_snd)) {
-		IF_DROP(&ifp->if_snd);
-		m_freem(m0);
+#ifdef ALTQ
+	IFQ_ENQUEUE(&ifp->if_snd, m0, &pktattr, error);
+#else
+	IFQ_ENQUEUE(&ifp->if_snd, m0, error);
+#endif
+	if (error) {
 		splx(s);
 		ifp->if_collisions++;
-		return ENOBUFS;
+		return (error);
 	}
-	ifp->if_obytes += m0->m_pkthdr.len;
-	IF_ENQUEUE(&ifp->if_snd, m0);
+	ifp->if_obytes += len;
 	splx(s);
 	ifp->if_opackets++;
 
@@ -499,8 +514,10 @@
 		break;
 	case FIONREAD:
 		s = splimp();
-		if (tp->tun_if.if_snd.ifq_head) {
-			struct mbuf *mb = tp->tun_if.if_snd.ifq_head;
+		if (!IFQ_IS_EMPTY(&tp->tun_if.if_snd)) {
+			struct mbuf *mb;
+
+			IFQ_POLL(&tp->tun_if.if_snd, mb);
 			for( *(int *)data = 0; mb != 0; mb = mb->m_next) 
 				*(int *)data += mb->m_len;
 		} else
@@ -555,7 +572,7 @@
 
 	s = splimp();
 	do {
-		IF_DEQUEUE(&ifp->if_snd, m0);
+		IFQ_DEQUEUE(&ifp->if_snd, m0);
 		if (m0 == 0) {
 			if (flag & IO_NDELAY) {
 				splx(s);
@@ -713,7 +730,7 @@
 	TUNDEBUG("%s%d: tunpoll\n", ifp->if_name, ifp->if_unit);
 
 	if (events & (POLLIN | POLLRDNORM)) {
-		if (ifp->if_snd.ifq_len > 0) {
+		if (!IFQ_IS_EMPTY(&ifp->if_snd)) {
 			TUNDEBUG("%s%d: tunpoll q=%d\n", ifp->if_name,
 			    ifp->if_unit, ifp->if_snd.ifq_len);
 			revents |= events & (POLLIN | POLLRDNORM);
@@ -729,3 +746,33 @@
 	splx(s);
 	return (revents);
 }
+
+#ifdef ALTQ
+/*
+ * Start packet transmission on the interface.
+ * when the interface queue is rate-limited by ALTQ or TBR,
+ * if_start is needed to drain packets from the queue in order
+ * to notify readers when outgoing packets become ready.
+ */
+static void
+tunstart(ifp)
+	struct ifnet *ifp;
+{
+	struct tun_softc *tp = ifp->if_softc;
+	struct mbuf *m;
+
+	if (!ALTQ_IS_ENABLED(&ifp->if_snd) && !TBR_IS_ENABLED(&ifp->if_snd))
+		return;
+
+	IFQ_POLL(&ifp->if_snd, m);
+	if (m != NULL) {
+		if (tp->tun_flags & TUN_RWAIT) {
+			tp->tun_flags &= ~TUN_RWAIT;
+			wakeup((caddr_t)tp);
+		}
+		if (tp->tun_flags & TUN_ASYNC && tp->tun_sigio)
+			pgsigio(tp->tun_sigio, SIGIO, 0);
+		selwakeup(&tp->tun_rsel);
+	}
+}
+#endif
